using System.Linq;
using EnvDTE;
using Microsoft.VisualStudio.TeamFoundation.WorkItemTracking;

namespace ScrumPowerTools.Models
{
    public class WorkItemSelectionService
    {
        private readonly DTE dte;
        private readonly DocumentService docService;

        public WorkItemSelectionService(DTE dte, DocumentService docService)
        {
            this.dte = dte;
            this.docService = docService;
        }

        public int GetFirstSelected()
        {
            Document activeDocument = dte.ActiveDocument;
            DocumentService globalService = docService;

            if ((activeDocument == null) || (globalService == null))
            {
                return 0;
            }

            string activeDocumentName = activeDocument.FullName;
            var resultsDocument = globalService.FindDocument(activeDocumentName, null) as IResultsDocument;

            if (resultsDocument != null)
            {
                return resultsDocument.SelectedItemIds.FirstOrDefault();
            }

            return 0;
        }

        public bool HasSelection()
        {
            return GetFirstSelected() != 0;
        }
    }
}