using System;
using System.IO;
using ScrumPowerTools.ViewModels;

namespace ScrumPowerTools.Model
{
    public class ReviewItemModel
    {
        public ReviewItemModel(ChangesetVisitEventArgs changesetVisitEventArgs)
        {
            ChangesetId = changesetVisitEventArgs.Changeset.ChangesetId;
            Comment = changesetVisitEventArgs.Changeset.Comment;
            CreationDate = changesetVisitEventArgs.Changeset.CreationDate;
            Committer = changesetVisitEventArgs.Committer;
        }

        public bool IsGroupExpanded { get; set; }

        public string Comment { get; internal set; }

        public int ChangesetId { get; internal set; }

        public DateTime CreationDate { get; internal set; }

        public string Committer { get; internal set; }

        public string ServerItem { get; internal set; }

        public string Change { get; internal set; }

        public string LocalFilePath { get; set; }

        public string Folder
        {
            get { return Path.GetDirectoryName(LocalFilePath); }
        }

        public string Description
        {
            get 
            { 
                return GroupingType == ReviewGrouping.File 
                ? ServerItem
                : Comment;
            }
        }

        public ReviewGrouping GroupingType { get; set; }

        public string Name
        {
            get { return Path.GetFileName(ServerItem); }
        }
    }
}